/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/pr2_ethercat_drivers/ethercat_hardware/msg/MotorTrace.msg.  Do not edit! */
#ifndef ETHERCAT_HARDWARE_MOTORTRACE_H
#define ETHERCAT_HARDWARE_MOTORTRACE_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "ethercat_hardware/BoardInfo.h"
#include "ethercat_hardware/ActuatorInfo.h"
#include "ethercat_hardware/MotorTraceSample.h"

namespace ethercat_hardware
{

//! \htmlinclude MotorTrace.msg.html

class MotorTrace : public ros::Message
{
public:
  typedef boost::shared_ptr<MotorTrace> Ptr;
  typedef boost::shared_ptr<MotorTrace const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef std::string _reason_type;
  typedef ethercat_hardware::BoardInfo _board_info_type;
  typedef ethercat_hardware::ActuatorInfo _actuator_info_type;
  typedef std::vector<ethercat_hardware::MotorTraceSample> _samples_type;

  roslib::Header header;
  std::string reason;
  ethercat_hardware::BoardInfo board_info;
  ethercat_hardware::ActuatorInfo actuator_info;
  std::vector<ethercat_hardware::MotorTraceSample> samples;

  MotorTrace() : ros::Message()
  {
  }
  MotorTrace(const MotorTrace &copy) : ros::Message(),
    header(copy.header),
    reason(copy.reason),
    board_info(copy.board_info),
    actuator_info(copy.actuator_info)
  {
    (void)copy;
    samples = copy.samples;
  }
  MotorTrace &operator =(const MotorTrace &copy)
  {
    if (this == &copy)
      return *this;
    samples.clear();
    header = copy.header;
    reason = copy.reason;
    board_info = copy.board_info;
    actuator_info = copy.actuator_info;
    samples = copy.samples;
    return *this;
  }
  virtual ~MotorTrace() 
  {
    samples.clear();
  }
  inline static std::string __s_getDataType() { return std::string("ethercat_hardware/MotorTrace"); }
  inline static std::string __s_getMD5Sum() { return std::string("ada0b8b7f00967d292bd5bb4f59d4bd8"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "Header header\n"
    "string reason\n"
    "ethercat_hardware/BoardInfo board_info\n"
    "ethercat_hardware/ActuatorInfo actuator_info\n"
    "ethercat_hardware/MotorTraceSample[] samples\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: ethercat_hardware/BoardInfo\n"
    "string description\n"
    "uint32 product_code\n"
    "uint32 pcb\n"
    "uint32 pca\n"
    "uint32 serial\n"
    "uint32 firmware_major\n"
    "uint32 firmware_minor\n"
    "float64 board_resistance\n"
    "float64 max_pwm_ratio\n"
    "float64 hw_max_current\n"
    "bool poor_measured_motor_voltage\n"
    "================================================================================\n"
    "MSG: ethercat_hardware/ActuatorInfo\n"
    "uint32 id\n"
    "string name\n"
    "string robot_name\n"
    "string motor_make\n"
    "string motor_model\n"
    "float64 max_current\n"
    "float64 speed_constant\n"
    "float64 motor_resistance\n"
    "float64 motor_torque_constant\n"
    "float64 encoder_reduction\n"
    "float64 pulses_per_revolution\n"
    "================================================================================\n"
    "MSG: ethercat_hardware/MotorTraceSample\n"
    "float64 timestamp\n"
    "bool    enabled\n"
    "float64 supply_voltage\n"
    "float64 measured_motor_voltage\n"
    "float64 programmed_pwm\n"
    "float64 executed_current\n"
    "float64 measured_current\n"
    "float64 velocity\n"
    "float64 encoder_position\n"
    "uint32  encoder_error_count\n"
    "float64 motor_voltage_error_limit\n"
    "float64 filtered_motor_voltage_error\n"
    "float64 filtered_abs_motor_voltage_error\n"
    "float64 filtered_measured_voltage_error\n"
    "float64 filtered_abs_measured_voltage_error\n"
    "float64 filtered_current_error\n"
    "float64 filtered_abs_current_error\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_samples_size(uint32_t __ros_new_size)
  {
    this->samples.resize(__ros_new_size);
  }
  inline uint32_t get_samples_size() const { return samples.size(); }
  inline void get_samples_vec (std::vector<ethercat_hardware::MotorTraceSample> &__ros_vec) const
  {
    __ros_vec = this->samples;
  }
  inline void set_samples_vec(const std::vector<ethercat_hardware::MotorTraceSample> &__ros_vec)
  {
    this->samples = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += header.serializationLength(); // header
    __l += 4 + reason.length(); // reason
    __l += board_info.serializationLength(); // board_info
    __l += actuator_info.serializationLength(); // actuator_info
    __l += 4 + (samples.size() ? samples.size() * samples[0].serializationLength() : 0); // samples
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    unsigned __ros_reason_len = reason.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_reason_len);
    SROS_SERIALIZE_BUFFER(write_ptr, reason.c_str(), __ros_reason_len);
    write_ptr = board_info.serialize(write_ptr, seq);
    write_ptr = actuator_info.serialize(write_ptr, seq);
    uint32_t __samples_size = samples.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __samples_size);
    for (size_t i = 0; i < __samples_size; i++)
      write_ptr = samples[i].serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    unsigned __ros_reason_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_reason_len);
    reason = std::string((const char *)read_ptr, __ros_reason_len);
    read_ptr += __ros_reason_len;
    read_ptr = board_info.deserialize(read_ptr);
    read_ptr = actuator_info.deserialize(read_ptr);
    uint32_t __samples_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __samples_size);
    set_samples_size(__samples_size);
    for (size_t i = 0; i < __samples_size; i++)
      read_ptr = samples[i].deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<MotorTrace> MotorTracePtr;
typedef boost::shared_ptr<MotorTrace const> MotorTraceConstPtr;


}

#endif
