/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/pr2_ethercat_drivers/fingertip_pressure/msg/PressureInfo.msg.  Do not edit! */
#ifndef FINGERTIP_PRESSURE_PRESSUREINFO_H
#define FINGERTIP_PRESSURE_PRESSUREINFO_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "geometry_msgs/Vector3.h"
#include "fingertip_pressure/PressureInfoElement.h"

namespace fingertip_pressure
{

//! \htmlinclude PressureInfo.msg.html

class PressureInfo : public ros::Message
{
public:
  typedef boost::shared_ptr<PressureInfo> Ptr;
  typedef boost::shared_ptr<PressureInfo const> ConstPtr;

  typedef std::vector<fingertip_pressure::PressureInfoElement> _sensor_type;

  std::vector<fingertip_pressure::PressureInfoElement> sensor;

  PressureInfo() : ros::Message()
  {
  }
  PressureInfo(const PressureInfo &copy) : ros::Message()
  {
    (void)copy;
    sensor = copy.sensor;
  }
  PressureInfo &operator =(const PressureInfo &copy)
  {
    if (this == &copy)
      return *this;
    sensor.clear();
    sensor = copy.sensor;
    return *this;
  }
  virtual ~PressureInfo() 
  {
    sensor.clear();
  }
  inline static std::string __s_getDataType() { return std::string("fingertip_pressure/PressureInfo"); }
  inline static std::string __s_getMD5Sum() { return std::string("a11fc5bae3534aa023741e378743af5b"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "PressureInfoElement[] sensor # List of pressure sensors for which information is being published\n"
    "\n"
    "================================================================================\n"
    "MSG: fingertip_pressure/PressureInfoElement\n"
    "string frame_id # Frame ID\n"
    "geometry_msgs/Vector3[] center # Corner of sensor (meters)\n"
    "geometry_msgs/Vector3[] halfside1 # Half of one edge of sensor (meters)\n"
    "geometry_msgs/Vector3[] halfside2 # Half of perpendicular edge of sensor (meters)\n"
    "# Sensor corners are at center+-halfside1+-halfside2\n"
    "# Cross product of halfside1 and halfside2 points out\n"
    "float64[] force_per_unit # Multiply this by the raw sensor value to get a force\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Vector3\n"
    "# This represents a vector in free space. \n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_sensor_size(uint32_t __ros_new_size)
  {
    this->sensor.resize(__ros_new_size);
  }
  inline uint32_t get_sensor_size() const { return sensor.size(); }
  uint32_t calc_sensor_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t sensor_size = sensor.size();
    for (size_t i = 0; i < sensor_size; i++)
      l += sensor[i].serializationLength();
    return l;
  }
  inline void get_sensor_vec (std::vector<fingertip_pressure::PressureInfoElement> &__ros_vec) const
  {
    __ros_vec = this->sensor;
  }
  inline void set_sensor_vec(const std::vector<fingertip_pressure::PressureInfoElement> &__ros_vec)
  {
    this->sensor = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 4 + calc_sensor_array_serialization_len(); // sensor
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    uint32_t __sensor_size = sensor.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __sensor_size);
    for (size_t i = 0; i < __sensor_size; i++)
      write_ptr = sensor[i].serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    uint32_t __sensor_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __sensor_size);
    set_sensor_size(__sensor_size);
    for (size_t i = 0; i < __sensor_size; i++)
      read_ptr = sensor[i].deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<PressureInfo> PressureInfoPtr;
typedef boost::shared_ptr<PressureInfo const> PressureInfoConstPtr;


}

#endif
