/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/pr2_ethercat_drivers/fingertip_pressure/msg/PressureInfoElement.msg.  Do not edit! */
#ifndef FINGERTIP_PRESSURE_PRESSUREINFOELEMENT_H
#define FINGERTIP_PRESSURE_PRESSUREINFOELEMENT_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "geometry_msgs/Vector3.h"

namespace fingertip_pressure
{

//! \htmlinclude PressureInfoElement.msg.html

class PressureInfoElement : public ros::Message
{
public:
  typedef boost::shared_ptr<PressureInfoElement> Ptr;
  typedef boost::shared_ptr<PressureInfoElement const> ConstPtr;

  typedef std::string _frame_id_type;
  typedef std::vector<geometry_msgs::Vector3> _center_type;
  typedef std::vector<geometry_msgs::Vector3> _halfside1_type;
  typedef std::vector<geometry_msgs::Vector3> _halfside2_type;
  typedef std::vector<double> _force_per_unit_type;

  std::string frame_id;
  std::vector<geometry_msgs::Vector3> center;
  std::vector<geometry_msgs::Vector3> halfside1;
  std::vector<geometry_msgs::Vector3> halfside2;
  std::vector<double> force_per_unit;

  PressureInfoElement() : ros::Message()
  {
  }
  PressureInfoElement(const PressureInfoElement &copy) : ros::Message(),
    frame_id(copy.frame_id)
  {
    (void)copy;
    center = copy.center;
    halfside1 = copy.halfside1;
    halfside2 = copy.halfside2;
    force_per_unit = copy.force_per_unit;
  }
  PressureInfoElement &operator =(const PressureInfoElement &copy)
  {
    if (this == &copy)
      return *this;
    center.clear();
    halfside1.clear();
    halfside2.clear();
    force_per_unit.clear();
    frame_id = copy.frame_id;
    center = copy.center;
    halfside1 = copy.halfside1;
    halfside2 = copy.halfside2;
    force_per_unit = copy.force_per_unit;
    return *this;
  }
  virtual ~PressureInfoElement() 
  {
    center.clear();
    halfside1.clear();
    halfside2.clear();
    force_per_unit.clear();
  }
  inline static std::string __s_getDataType() { return std::string("fingertip_pressure/PressureInfoElement"); }
  inline static std::string __s_getMD5Sum() { return std::string("1cb486bb542ab85e1ff8d84fe9cc899f"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "string frame_id # Frame ID\n"
    "geometry_msgs/Vector3[] center # Corner of sensor (meters)\n"
    "geometry_msgs/Vector3[] halfside1 # Half of one edge of sensor (meters)\n"
    "geometry_msgs/Vector3[] halfside2 # Half of perpendicular edge of sensor (meters)\n"
    "# Sensor corners are at center+-halfside1+-halfside2\n"
    "# Cross product of halfside1 and halfside2 points out\n"
    "float64[] force_per_unit # Multiply this by the raw sensor value to get a force\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Vector3\n"
    "# This represents a vector in free space. \n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_center_size(uint32_t __ros_new_size)
  {
    this->center.resize(__ros_new_size);
  }
  inline uint32_t get_center_size() const { return center.size(); }
  inline void get_center_vec (std::vector<geometry_msgs::Vector3> &__ros_vec) const
  {
    __ros_vec = this->center;
  }
  inline void set_center_vec(const std::vector<geometry_msgs::Vector3> &__ros_vec)
  {
    this->center = __ros_vec;
  }
  void set_halfside1_size(uint32_t __ros_new_size)
  {
    this->halfside1.resize(__ros_new_size);
  }
  inline uint32_t get_halfside1_size() const { return halfside1.size(); }
  inline void get_halfside1_vec (std::vector<geometry_msgs::Vector3> &__ros_vec) const
  {
    __ros_vec = this->halfside1;
  }
  inline void set_halfside1_vec(const std::vector<geometry_msgs::Vector3> &__ros_vec)
  {
    this->halfside1 = __ros_vec;
  }
  void set_halfside2_size(uint32_t __ros_new_size)
  {
    this->halfside2.resize(__ros_new_size);
  }
  inline uint32_t get_halfside2_size() const { return halfside2.size(); }
  inline void get_halfside2_vec (std::vector<geometry_msgs::Vector3> &__ros_vec) const
  {
    __ros_vec = this->halfside2;
  }
  inline void set_halfside2_vec(const std::vector<geometry_msgs::Vector3> &__ros_vec)
  {
    this->halfside2 = __ros_vec;
  }
  void set_force_per_unit_size(uint32_t __ros_new_size)
  {
    this->force_per_unit.resize(__ros_new_size);
  }
  inline uint32_t get_force_per_unit_size() const { return force_per_unit.size(); }
  inline void get_force_per_unit_vec (std::vector<double> &__ros_vec) const
  {
    __ros_vec = this->force_per_unit;
  }
  inline void set_force_per_unit_vec(const std::vector<double> &__ros_vec)
  {
    this->force_per_unit = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 4 + frame_id.length(); // frame_id
    __l += 4 + (center.size() ? center.size() * center[0].serializationLength() : 0); // center
    __l += 4 + (halfside1.size() ? halfside1.size() * halfside1[0].serializationLength() : 0); // halfside1
    __l += 4 + (halfside2.size() ? halfside2.size() * halfside2[0].serializationLength() : 0); // halfside2
    __l += 4 + (force_per_unit.size() ? force_per_unit.size() * 8 : 0); // force_per_unit
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    unsigned __ros_frame_id_len = frame_id.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_frame_id_len);
    SROS_SERIALIZE_BUFFER(write_ptr, frame_id.c_str(), __ros_frame_id_len);
    uint32_t __center_size = center.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __center_size);
    for (size_t i = 0; i < __center_size; i++)
      write_ptr = center[i].serialize(write_ptr, seq);
    uint32_t __halfside1_size = halfside1.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __halfside1_size);
    for (size_t i = 0; i < __halfside1_size; i++)
      write_ptr = halfside1[i].serialize(write_ptr, seq);
    uint32_t __halfside2_size = halfside2.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __halfside2_size);
    for (size_t i = 0; i < __halfside2_size; i++)
      write_ptr = halfside2[i].serialize(write_ptr, seq);
    uint32_t __force_per_unit_size = force_per_unit.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __force_per_unit_size);
    memcpy(write_ptr, &force_per_unit[0], sizeof(double) * __force_per_unit_size);
    write_ptr += sizeof(double) * __force_per_unit_size;
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    unsigned __ros_frame_id_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_frame_id_len);
    frame_id = std::string((const char *)read_ptr, __ros_frame_id_len);
    read_ptr += __ros_frame_id_len;
    uint32_t __center_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __center_size);
    set_center_size(__center_size);
    for (size_t i = 0; i < __center_size; i++)
      read_ptr = center[i].deserialize(read_ptr);
    uint32_t __halfside1_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __halfside1_size);
    set_halfside1_size(__halfside1_size);
    for (size_t i = 0; i < __halfside1_size; i++)
      read_ptr = halfside1[i].deserialize(read_ptr);
    uint32_t __halfside2_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __halfside2_size);
    set_halfside2_size(__halfside2_size);
    for (size_t i = 0; i < __halfside2_size; i++)
      read_ptr = halfside2[i].deserialize(read_ptr);
    uint32_t __force_per_unit_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __force_per_unit_size);
    set_force_per_unit_size(__force_per_unit_size);
    memcpy(&force_per_unit[0], read_ptr, sizeof(double) * __force_per_unit_size);
    read_ptr += sizeof(double) * __force_per_unit_size;
    return read_ptr;
  }
};

typedef boost::shared_ptr<PressureInfoElement> PressureInfoElementPtr;
typedef boost::shared_ptr<PressureInfoElement const> PressureInfoElementConstPtr;


}

#endif
