# autogenerated by genmsg_py from PressureInfo.msg. Do not edit.
import roslib.message
import struct

import geometry_msgs.msg
import fingertip_pressure.msg

class PressureInfo(roslib.message.Message):
  _md5sum = "a11fc5bae3534aa023741e378743af5b"
  _type = "fingertip_pressure/PressureInfo"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """PressureInfoElement[] sensor # List of pressure sensors for which information is being published

================================================================================
MSG: fingertip_pressure/PressureInfoElement
string frame_id # Frame ID
geometry_msgs/Vector3[] center # Corner of sensor (meters)
geometry_msgs/Vector3[] halfside1 # Half of one edge of sensor (meters)
geometry_msgs/Vector3[] halfside2 # Half of perpendicular edge of sensor (meters)
# Sensor corners are at center+-halfside1+-halfside2
# Cross product of halfside1 and halfside2 points out
float64[] force_per_unit # Multiply this by the raw sensor value to get a force

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
"""
  __slots__ = ['sensor']
  _slot_types = ['fingertip_pressure/PressureInfoElement[]']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   sensor
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(PressureInfo, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.sensor is None:
        self.sensor = []
    else:
      self.sensor = []

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      #serialize self.sensor
      length = len(self.sensor)
      buff.write(struct.pack('<I', length))
      for val1 in self.sensor:
        length = len(val1.frame_id)
        #serialize val1.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.frame_id))
        #serialize val1.center
        length = len(val1.center)
        buff.write(struct.pack('<I', length))
        for val2 in val1.center:
          buff.write(struct.pack('<3d', val2.x, val2.y, val2.z))
        #serialize val1.halfside1
        length = len(val1.halfside1)
        buff.write(struct.pack('<I', length))
        for val2 in val1.halfside1:
          buff.write(struct.pack('<3d', val2.x, val2.y, val2.z))
        #serialize val1.halfside2
        length = len(val1.halfside2)
        buff.write(struct.pack('<I', length))
        for val2 in val1.halfside2:
          buff.write(struct.pack('<3d', val2.x, val2.y, val2.z))
        #serialize val1.force_per_unit
        length = len(val1.force_per_unit)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.force_per_unit))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      end = 0
      #deserialize self.sensor
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.sensor = []
      for i in xrange(0, length):
        val1 = fingertip_pressure.msg.PressureInfoElement()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.frame_id,) = struct.unpack(pattern, str[start:end])
        #deserialize val1.center
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.center = []
        for i in xrange(0, length):
          val2 = geometry_msgs.msg.Vector3()
          start = end
          end += 24
          (val2.x, val2.y, val2.z,) = struct.unpack('<3d',str[start:end])
          val1.center.append(val2)
        #deserialize val1.halfside1
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.halfside1 = []
        for i in xrange(0, length):
          val2 = geometry_msgs.msg.Vector3()
          start = end
          end += 24
          (val2.x, val2.y, val2.z,) = struct.unpack('<3d',str[start:end])
          val1.halfside1.append(val2)
        #deserialize val1.halfside2
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.halfside2 = []
        for i in xrange(0, length):
          val2 = geometry_msgs.msg.Vector3()
          start = end
          end += 24
          (val2.x, val2.y, val2.z,) = struct.unpack('<3d',str[start:end])
          val1.halfside2.append(val2)
        #deserialize val1.force_per_unit
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.force_per_unit = struct.unpack(pattern, str[start:end])
        self.sensor.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      #serialize self.sensor
      length = len(self.sensor)
      buff.write(struct.pack('<I', length))
      for val1 in self.sensor:
        length = len(val1.frame_id)
        #serialize val1.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.frame_id))
        #serialize val1.center
        length = len(val1.center)
        buff.write(struct.pack('<I', length))
        for val2 in val1.center:
          buff.write(struct.pack('<3d', val2.x, val2.y, val2.z))
        #serialize val1.halfside1
        length = len(val1.halfside1)
        buff.write(struct.pack('<I', length))
        for val2 in val1.halfside1:
          buff.write(struct.pack('<3d', val2.x, val2.y, val2.z))
        #serialize val1.halfside2
        length = len(val1.halfside2)
        buff.write(struct.pack('<I', length))
        for val2 in val1.halfside2:
          buff.write(struct.pack('<3d', val2.x, val2.y, val2.z))
        #serialize val1.force_per_unit
        length = len(val1.force_per_unit)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(val1.force_per_unit.tostring())
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      end = 0
      #deserialize self.sensor
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.sensor = []
      for i in xrange(0, length):
        val1 = fingertip_pressure.msg.PressureInfoElement()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.frame_id,) = struct.unpack(pattern, str[start:end])
        #deserialize val1.center
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.center = []
        for i in xrange(0, length):
          val2 = geometry_msgs.msg.Vector3()
          start = end
          end += 24
          (val2.x, val2.y, val2.z,) = struct.unpack('<3d',str[start:end])
          val1.center.append(val2)
        #deserialize val1.halfside1
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.halfside1 = []
        for i in xrange(0, length):
          val2 = geometry_msgs.msg.Vector3()
          start = end
          end += 24
          (val2.x, val2.y, val2.z,) = struct.unpack('<3d',str[start:end])
          val1.halfside1.append(val2)
        #deserialize val1.halfside2
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.halfside2 = []
        for i in xrange(0, length):
          val2 = geometry_msgs.msg.Vector3()
          start = end
          end += 24
          (val2.x, val2.y, val2.z,) = struct.unpack('<3d',str[start:end])
          val1.halfside2.append(val2)
        #deserialize val1.force_per_unit
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.force_per_unit = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        self.sensor.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

