# autogenerated by genmsg_py from PressureInfoElement.msg. Do not edit.
import roslib.message
import struct

import geometry_msgs.msg

class PressureInfoElement(roslib.message.Message):
  _md5sum = "1cb486bb542ab85e1ff8d84fe9cc899f"
  _type = "fingertip_pressure/PressureInfoElement"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """string frame_id # Frame ID
geometry_msgs/Vector3[] center # Corner of sensor (meters)
geometry_msgs/Vector3[] halfside1 # Half of one edge of sensor (meters)
geometry_msgs/Vector3[] halfside2 # Half of perpendicular edge of sensor (meters)
# Sensor corners are at center+-halfside1+-halfside2
# Cross product of halfside1 and halfside2 points out
float64[] force_per_unit # Multiply this by the raw sensor value to get a force

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
"""
  __slots__ = ['frame_id','center','halfside1','halfside2','force_per_unit']
  _slot_types = ['string','geometry_msgs/Vector3[]','geometry_msgs/Vector3[]','geometry_msgs/Vector3[]','float64[]']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   frame_id,center,halfside1,halfside2,force_per_unit
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(PressureInfoElement, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.frame_id is None:
        self.frame_id = ''
      if self.center is None:
        self.center = []
      if self.halfside1 is None:
        self.halfside1 = []
      if self.halfside2 is None:
        self.halfside2 = []
      if self.force_per_unit is None:
        self.force_per_unit = []
    else:
      self.frame_id = ''
      self.center = []
      self.halfside1 = []
      self.halfside2 = []
      self.force_per_unit = []

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      length = len(self.frame_id)
      #serialize self.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.frame_id))
      #serialize self.center
      length = len(self.center)
      buff.write(struct.pack('<I', length))
      for val1 in self.center:
        buff.write(struct.pack('<3d', val1.x, val1.y, val1.z))
      #serialize self.halfside1
      length = len(self.halfside1)
      buff.write(struct.pack('<I', length))
      for val1 in self.halfside1:
        buff.write(struct.pack('<3d', val1.x, val1.y, val1.z))
      #serialize self.halfside2
      length = len(self.halfside2)
      buff.write(struct.pack('<I', length))
      for val1 in self.halfside2:
        buff.write(struct.pack('<3d', val1.x, val1.y, val1.z))
      #serialize self.force_per_unit
      length = len(self.force_per_unit)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.force_per_unit))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      end = 0
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.center
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.center = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Vector3()
        start = end
        end += 24
        (val1.x, val1.y, val1.z,) = struct.unpack('<3d',str[start:end])
        self.center.append(val1)
      #deserialize self.halfside1
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.halfside1 = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Vector3()
        start = end
        end += 24
        (val1.x, val1.y, val1.z,) = struct.unpack('<3d',str[start:end])
        self.halfside1.append(val1)
      #deserialize self.halfside2
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.halfside2 = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Vector3()
        start = end
        end += 24
        (val1.x, val1.y, val1.z,) = struct.unpack('<3d',str[start:end])
        self.halfside2.append(val1)
      #deserialize self.force_per_unit
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.force_per_unit = struct.unpack(pattern, str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      length = len(self.frame_id)
      #serialize self.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.frame_id))
      #serialize self.center
      length = len(self.center)
      buff.write(struct.pack('<I', length))
      for val1 in self.center:
        buff.write(struct.pack('<3d', val1.x, val1.y, val1.z))
      #serialize self.halfside1
      length = len(self.halfside1)
      buff.write(struct.pack('<I', length))
      for val1 in self.halfside1:
        buff.write(struct.pack('<3d', val1.x, val1.y, val1.z))
      #serialize self.halfside2
      length = len(self.halfside2)
      buff.write(struct.pack('<I', length))
      for val1 in self.halfside2:
        buff.write(struct.pack('<3d', val1.x, val1.y, val1.z))
      #serialize self.force_per_unit
      length = len(self.force_per_unit)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.force_per_unit.tostring())
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      end = 0
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.center
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.center = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Vector3()
        start = end
        end += 24
        (val1.x, val1.y, val1.z,) = struct.unpack('<3d',str[start:end])
        self.center.append(val1)
      #deserialize self.halfside1
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.halfside1 = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Vector3()
        start = end
        end += 24
        (val1.x, val1.y, val1.z,) = struct.unpack('<3d',str[start:end])
        self.halfside1.append(val1)
      #deserialize self.halfside2
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.halfside2 = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Vector3()
        start = end
        end += 24
        (val1.x, val1.y, val1.z,) = struct.unpack('<3d',str[start:end])
        self.halfside2.append(val1)
      #deserialize self.force_per_unit
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.force_per_unit = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

